//+------------------------------------------------------------------+
//|                                                    Templates.mq5 |
//|                                            Copyright 2010, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
#property version   "1.00"
#property script_show_inputs

#define startread "//__"
#define endread "//__"
/*///---     
"long;double;datetime;string"
"int;float,int,string"
/*///---
input string folder="Example templat";//    
//+------------------------------------------------------------------+
input string type="long;double;datetime;string"
            ;//  , delimit ";"
string TEMPLAT="_XXX_";//  
//+------------------------------------------------------------------+
input string type2="int;float;int;string"
             ;//  , delimit ";"
string TEMPLAT2="_xxx_";//   
//+------------------------------------------------------------------+

string type_dates[]; //    
string type_dates2[];// 2-     
string fdates[];     //    
string tempfdates[]; //  
bool flagnew=false;  //   -  
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
   Init_buf_type_dates();       //  type_dates[],type_dates2[]
   ReadFile();                  //  
   WriteFile(ArraySize(fdates));//  ,    
  }
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void Init_buf_type_dates()
  {
   ParserInputType(0,type_dates,type);
   ParserInputType(0,type_dates2,type2);
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
void Replace(string &temp_m[],int i,int j)
  {
   if(i>=ArraySize(temp_m))return;
   if(j<ArraySize(type_dates))
      StringReplac(temp_m[i],TEMPLAT,type_dates[j]);//  templat 
   if(j<ArraySize(type_dates2))
      StringReplac(temp_m[i],TEMPLAT2,type_dates2[j]);//  templat2 2
  }
///////////////////////////////////////////////////////////////////////////////////////
//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ 
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void ReadFile()
  {
   string subfolder="Templates";
   int han=FileOpen(subfolder+"\\"+folder+".mqh",FILE_READ|FILE_SHARE_READ|FILE_TXT|FILE_ANSI,"\r");
   if(han!=INVALID_HANDLE)
     {
      string temp="";
      //---     
      do{temp=FileReadString(han);StringTrimLeft(temp);StringTrimRight(temp); }
      while(startread!=temp);

      string text=""; int size;
      //---    ,       
      while(!FileIsEnding(han))
        {
         temp=text=FileReadString(han);
         //      
         StringTrimLeft(temp);StringTrimRight(temp);
         if(endread==temp)break;
         //    
         if(text!="")
           {
            size=ArraySize(fdates);
            ArrayResize(fdates,size+1);
            fdates[size]=text;
           }
        }
      FileClose(han);
     }
   else
     {
      Print("File open failed"+subfolder+"\\"+folder+".mqh, error",GetLastError());
      flagnew=true;
     }
  }
//+------------------------------------------------------------------+
//|                                                       |
//+------------------------------------------------------------------+ 
void WriteFile(int count)
  {
   string newfolder;
   if(flagnew)newfolder=folder;//         
   else newfolder=StringDel(folder," templat");//      

   string subfolder="Templates";
   int han=FileOpen(subfolder+"\\"+newfolder+".mqh",FILE_WRITE|FILE_SHARE_WRITE|FILE_TXT|FILE_ANSI,"\r");
   if(han!=INVALID_HANDLE)
     {
      if(flagnew)//     
        {//    
         FileWrite(han,"//#define "+TEMPLAT+" "+type_dates[0]);
         FileWrite(han," ");
         FileWrite(han,startread);
         FileWrite(han," "+TEMPLAT);
         FileWrite(han,endread);
         Print("   "+subfolder+"\\"+folder+".mqh");
        }
      else
        {//   
         ArrayResize(tempfdates,count);
         int count_type=ArraySize(type_dates);
         //---         type_dates
         for(int j=0;j<count_type;j++)
           {
            for(int i=0;i<count;i++)//     
               tempfdates[i]=fdates[i];
            for(int i=0;i<count;i++)//   
               Replace(tempfdates,i,j);

            for(int i=0;i<count;i++)
               FileWrite(han,tempfdates[i]);//    
           }
        }
      FileClose(han);
      Print("   "+subfolder+"\\"+newfolder+".mqh");
     }
   else Print("File open failed"+subfolder+"\\"+newfolder+".mqh, error",GetLastError());
  }
//+------------------------------------------------------------------+
//|   find   text                             |
//+------------------------------------------------------------------+
string StringDel(string text,const string find)
  {
   string  str=text;
   StringReplace(str,find,"");
   return(str);
  }
//+------------------------------------------------------------------+
//|                                                      |
//+------------------------------------------------------------------+
void ParserInputType(int i,string &type_d[],string text)
  {//    string text   ,  ";"
   if(text=="")return;
   int len=StringLen(text);
   string temptext=text;
   int end=PosDelimit(temptext);// end        
   if(end==-1)end=len;
   ArrayResize(type_d,ArraySize(type_d)+1);
   string temp=StringSubstr(temptext,0,end);
   int td=PosDelimit(temp);
   if(td>0)StringSetCharacter(temp,td-1,NULL);
   type_d[i]=temp;
   ParserInputType(i+1,type_d,StringSubstr(temptext,end,len-end));
  }
//+------------------------------------------------------------------+
//|                               |
//+------------------------------------------------------------------+
int PosDelimit(string text)
  {
   int res=StringFind(text,";");
   if(res!=-1)return(res+1);
   else return(-1);
  }
//+------------------------------------------------------------------+
//| StringReplac  StringReplace,   ...            |
//| ...    REPLACEMENT  find        |
//| "  "   find  ,  |
//+------------------------------------------------------------------+
void  StringReplac(string         &text,             // ,     
                   const string    find,             //  
                   const string    replacement,      // ,      
                   int start=0                       //    
                   )
  {
   if(text=="")return;
   string REPLACEMENT=replacement; StringToUpper(REPLACEMENT);
   int lenfind=StringLen(find);
   int len=StringLen(text);
   if(len-start<lenfind)return;
   for(int i=start;i<len-lenfind;i++)
     {
      if(StringSubstr(text,i,lenfind)==find)
        {  
         //  ,    find   
         // 32,160  40( 41) 123{ 125} 130 44, 59; 91[ 93]
         if((StringGetCharacter(text,i-1)==32 || 
            StringGetCharacter(text,i-1)==160||
            StringGetCharacter(text,i-1)==40||
            //StringGetCharacter(text,i-1)==41||
            StringGetCharacter(text,i-1)==123||
            StringGetCharacter(text,i-1)==125||
            StringGetCharacter(text,i-1)==44||
            StringGetCharacter(text,i-1)==59||
            StringGetCharacter(text,i-1)==130
            )
            || i==0)
            text=StringSubstr(text,0,i)+replacement+StringSubstr(text,i+lenfind,len-(i+lenfind));
         else text=StringSubstr(text,0,i)+REPLACEMENT+StringSubstr(text,i+lenfind,len-(i+lenfind));
         StringReplac(text,find,replacement,i);
         break;
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
